REM http://download.qt-project.org/archive/qt/4.7/qt-everywhere-opensource-src-4.7.1.tar.gz

path %SYSTEMROOT%\system32;%SYSTEMROOT%;%SYSTEMROOT%\System32\Wbem

set VS90COMNTOOLS=%PROGRAMFILES%\Microsoft Visual Studio 9.0\Common7\Tools\
call "%PROGRAMFILES%\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x86
set OSGEO4W_ROOT=C:\OSGeo4W
set P=%PATH%
call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
echo on
path %P%;c:\OSGeo4W\bin;C:\cygwin\bin

set VERSION=4.7.1
set PACKAGE=5

set QT_BUILD_PARTS=libs tools docs translations
set QMAKESPEC=win32-msvc2008

echo START: %DATE% %TIME%

set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\apps\OpenSSL\include;%OSGEO4W_ROOT%\include
set LIB=%LIB%;%OSGEO4W_ROOT%\apps\OpenSSL\lib;%OSGEO4W_ROOT%\lib
set APPDIR=%OSGEO4W_ROOT%\apps\Qt4

if exist repackage goto package
if exist reconfigure goto reconfigure
if not exist makefile goto configure
if exist clean goto clean
goto build

:reconfigure
del reconfigure
nmake confclean

:configure
echo CONFIGURE: %DATE% %TIME%
echo y>answer
set CONFIGURE=configure.exe ^
	-opensource ^
	-fast ^
	-prefix %OSGEO4W_ROOT% ^
	-bindir %OSGEO4W_ROOT%\bin ^
	-libdir %OSGEO4W_ROOT%\lib ^
	-docdir %APPDIR%\doc ^
	-importdir %APPDIR%\imports ^
	-headerdir %OSGEO4W_ROOT%\include\qt4 ^
	-datadir %APPDIR% ^
	-plugindir %APPDIR%\plugins ^
	-translationdir %APPDIR%\translations ^
	-platform %QMAKESPEC% ^
	-debug-and-release ^
	-system-zlib ^
	-qt-libjpeg ^
	-openssl ^
	-system-libpng ^
	-qt-sql-odbc ^
	-qt-sql-psql ^
	-plugin-sql-oci
%CONFIGURE%<answer
if errorlevel 1 goto error
del answer

REM disable demos and examples
bin\qmake -spec %OSGEO4W_ROOT%\apps\Qt4\mkspecs\%QMAKESPEC% -win32 QT_BUILD_PARTS="%QT_BUILD_PARTS%" -o Makefile projects.pro

REM first configure will break trying to find mkspecs in source directory
del /s /q %APPDIR%
mkdir %OSGEO4W_ROOT%\apps\Qt4\mkspecs
xcopy /s /e mkspecs %APPDIR%\mkspecs

REM rerun with copied mkspecs
%CONFIGURE%<answer

:clean
if exist install-stamp (
	jom uninstall
	del install-stamp
)

jom clean
if exist build-stamp del build-stamp

:build
if exist build-stamp goto install

REM build it
echo MAKE: %DATE% %TIME%
jom /j8 /k
if errorlevel 1 jom /j8
if errorlevel 1 goto error

if exist nopackage goto end

echo >build-stamp

:install
if exist install-stamp goto package
REM install it
echo INSTALL: %DATE% %TIME%
jom install
if errorlevel 1 goto error

echo >install-stamp

:package
echo PACKAGE: %DATE% %TIME%

tar -C %OSGEO4W_ROOT% -cjf qt4-doc-%VERSION%-%PACKAGE%.tar.bz2 ^
	apps/Qt4/doc

tar -C %OSGEO4W_ROOT% -cjf qt4-devel-%VERSION%-%PACKAGE%.tar.bz2 ^
	--exclude apps/Qt4/plugins/designer/pythonplugin.dll ^
	--exclude apps/Qt4/plugins/designer/qwt_designer_plugin5.dll ^
	apps/Qt4/mkspecs ^
	apps/Qt4/phrasebooks ^
	apps/Qt4/plugins/designer ^
	apps/Qt4/translations/assistant_cs.qm ^
	apps/Qt4/translations/assistant_da.qm ^
	apps/Qt4/translations/assistant_de.qm ^
	apps/Qt4/translations/assistant_fr.qm ^
	apps/Qt4/translations/assistant_hu.qm ^
	apps/Qt4/translations/assistant_ja.qm ^
	apps/Qt4/translations/assistant_pl.qm ^
	apps/Qt4/translations/assistant_ru.qm ^
	apps/Qt4/translations/assistant_sl.qm ^
	apps/Qt4/translations/assistant_uk.qm ^
	apps/Qt4/translations/assistant_zh_CN.qm ^
	apps/Qt4/translations/assistant_zh_TW.qm ^
	apps/Qt4/translations/designer_cs.qm ^
	apps/Qt4/translations/designer_de.qm ^
	apps/Qt4/translations/designer_fr.qm ^
	apps/Qt4/translations/designer_hu.qm ^
	apps/Qt4/translations/designer_ja.qm ^
	apps/Qt4/translations/designer_pl.qm ^
	apps/Qt4/translations/designer_ru.qm ^
	apps/Qt4/translations/designer_sl.qm ^
	apps/Qt4/translations/designer_uk.qm ^
	apps/Qt4/translations/designer_zh_CN.qm ^
	apps/Qt4/translations/designer_zh_TW.qm ^
	apps/Qt4/translations/linguist_cs.qm ^
	apps/Qt4/translations/linguist_de.qm ^
	apps/Qt4/translations/linguist_fr.qm ^
	apps/Qt4/translations/linguist_hu.qm ^
	apps/Qt4/translations/linguist_ja.qm ^
	apps/Qt4/translations/linguist_pl.qm ^
	apps/Qt4/translations/linguist_ru.qm ^
	apps/Qt4/translations/linguist_sl.qm ^
	apps/Qt4/translations/linguist_uk.qm ^
	apps/Qt4/translations/linguist_zh_CN.qm ^
	apps/Qt4/translations/linguist_zh_TW.qm ^
	apps/Qt4/translations/qtconfig_hu.qm ^
	apps/Qt4/translations/qtconfig_ja.qm ^
	apps/Qt4/translations/qtconfig_pl.qm ^
	apps/Qt4/translations/qtconfig_ru.qm ^
	apps/Qt4/translations/qtconfig_sl.qm ^
	apps/Qt4/translations/qtconfig_uk.qm ^
	apps/Qt4/translations/qtconfig_zh_CN.qm ^
	apps/Qt4/translations/qtconfig_zh_TW.qm ^
	apps/Qt4/translations/qvfb_hu.qm ^
	apps/Qt4/translations/qvfb_ja.qm ^
	apps/Qt4/translations/qvfb_pl.qm ^
	apps/Qt4/translations/qvfb_ru.qm ^
	apps/Qt4/translations/qvfb_sl.qm ^
	apps/Qt4/translations/qvfb_uk.qm ^
	apps/Qt4/translations/qvfb_zh_CN.qm ^
	apps/Qt4/translations/qvfb_zh_TW.qm ^
	apps/Qt4/q3porting.xml ^
	bin/assistant.exe ^
	bin/designer.exe ^
	bin/idc.exe ^
	bin/lconvert.exe ^
	bin/linguist.exe ^
	bin/lrelease.exe ^
	bin/lupdate.exe ^
	bin/moc.exe ^
	bin/pixeltool.exe ^
	bin/qcollectiongenerator.exe ^
	bin/qdoc3.exe ^
	bin/qhelpconverter.exe ^
	bin/qhelpgenerator.exe ^
	bin/qmake.exe ^
	bin/qmlviewer.exe ^
	bin/qt3to4.exe ^
	bin/qttracereplay.exe ^
	bin/rcc.exe ^
	bin/uic.exe ^
	bin/uic3.exe ^
	bin/xmlpatterns.exe ^
	bin/xmlpatternsvalidator.exe ^
	include/qt4 ^
	lib/Qt3Support.prl ^
	lib/Qt3Support4.lib ^
	lib/QtCLucene.prl ^
	lib/QtCLucene4.lib ^
	lib/QtCore.prl ^
	lib/QtCore4.lib ^
	lib/QtDeclarative.prl ^
	lib/QtDeclarative4.lib ^
	lib/QtDesigner.prl ^
	lib/QtDesigner4.lib ^
	lib/QtDesignerComponents.prl ^
	lib/QtDesignerComponents4.lib ^
	lib/QtGui.prl ^
	lib/QtGui4.lib ^
	lib/QtHelp.prl ^
	lib/QtHelp4.lib ^
	lib/QtNetwork.prl ^
	lib/QtNetwork4.lib ^
	lib/QtOpenGL.prl ^
	lib/QtOpenGL4.lib ^
	lib/QtScript.prl ^
	lib/QtScript4.lib ^
	lib/QtScriptTools.prl ^
	lib/QtScriptTools4.lib ^
	lib/QtSql.prl ^
	lib/QtSql4.lib ^
	lib/QtSvg.prl ^
	lib/QtSvg4.lib ^
	lib/QtTest.prl ^
	lib/QtTest4.lib ^
	lib/QtUiTools.lib ^
	lib/QtUiTools.prl ^
	lib/QtWebKit.prl ^
	lib/QtWebKit4.lib ^
	lib/QtXml.prl ^
	lib/QtXml4.lib ^
	lib/QtXmlPatterns.prl ^
	lib/QtXmlPatterns4.lib ^
	lib/phonon.prl ^
	lib/phonon4.lib ^
	lib/qaxcontainer.lib ^
	lib/qaxcontainer.prl ^
	lib/qaxserver.lib ^
	lib/qaxserver.prl ^
	lib/qtmain.lib ^
	lib/qtmain.prl ^
	lib/qtmultimedia.prl ^
	lib/qtmultimedia4.lib

copy qt.conf.tmpl %OSGEO4W_ROOT%\bin
copy qt4.bat %OSGEO4W_ROOT%\etc\ini
copy postinstall.bat %OSGEO4W_ROOT%\etc\postinstall\qt4-libs.bat
copy preremove.bat %OSGEO4W_ROOT%\etc\preremove\qt4-libs.bat

tar -C %OSGEO4W_ROOT% -cjf qt4-libs-%VERSION%-%PACKAGE%.tar.bz2 ^
	--exclude-from libs.debug ^
	apps/Qt4/plugins/codecs ^
	apps/Qt4/plugins/iconengines ^
	apps/Qt4/plugins/imageformats ^
	apps/Qt4/plugins/phonon_backend ^
	apps/Qt4/plugins/sqldrivers ^
	apps/Qt4/translations/qt_ar.qm ^
	apps/Qt4/translations/qt_cs.qm ^
	apps/Qt4/translations/qt_da.qm ^
	apps/Qt4/translations/qt_de.qm ^
	apps/Qt4/translations/qt_es.qm ^
	apps/Qt4/translations/qt_fr.qm ^
	apps/Qt4/translations/qt_he.qm ^
	apps/Qt4/translations/qt_help_cs.qm ^
	apps/Qt4/translations/qt_help_da.qm ^
	apps/Qt4/translations/qt_help_de.qm ^
	apps/Qt4/translations/qt_help_fr.qm ^
	apps/Qt4/translations/qt_help_hu.qm ^
	apps/Qt4/translations/qt_help_ja.qm ^
	apps/Qt4/translations/qt_help_pl.qm ^
	apps/Qt4/translations/qt_help_ru.qm ^
	apps/Qt4/translations/qt_help_sl.qm ^
	apps/Qt4/translations/qt_help_uk.qm ^
	apps/Qt4/translations/qt_help_zh_CN.qm ^
	apps/Qt4/translations/qt_help_zh_TW.qm ^
	apps/Qt4/translations/qt_hu.qm ^
	apps/Qt4/translations/qt_ja.qm ^
	apps/Qt4/translations/qt_pl.qm ^
	apps/Qt4/translations/qt_pt.qm ^
	apps/Qt4/translations/qt_ru.qm ^
	apps/Qt4/translations/qt_sk.qm ^
	apps/Qt4/translations/qt_sl.qm ^
	apps/Qt4/translations/qt_sv.qm ^
	apps/Qt4/translations/qt_uk.qm ^
	apps/Qt4/translations/qt_zh_CN.qm ^
	apps/Qt4/translations/qt_zh_TW.qm ^
	apps/Qt4/plugins/accessible ^
	apps/Qt4/plugins/bearer ^
	apps/Qt4/plugins/graphicssystems ^
	apps/Qt4/imports ^
	bin/Qt3Support4.dll ^
	bin/qtmultimedia4.dll ^
	bin/QtCLucene4.dll ^
	bin/QtCore4.dll ^
	bin/QtDesigner4.dll ^
	bin/QtDesignerComponents4.dll ^
	bin/QtDeclarative4.dll ^
	bin/QtGui4.dll ^
	bin/QtHelp4.dll ^
	bin/QtNetwork4.dll ^
	bin/QtOpenGL4.dll ^
	bin/QtScript4.dll ^
	bin/QtScriptTools4.dll ^
	bin/QtSql4.dll ^
	bin/QtSvg4.dll ^
	bin/QtTest4.dll ^
	bin/QtWebKit4.dll ^
	bin/QtXml4.dll ^
	bin/QtXmlPatterns4.dll ^
	bin/phonon4.dll ^
	bin/qt.conf.tmpl ^
	etc/ini/qt4.bat ^
	etc/postinstall/qt4-libs.bat ^
	etc/preremove/qt4-libs.bat


tar -C %OSGEO4W_ROOT% -cjf qt4-libs-debug-%VERSION%-%PACKAGE%.tar.bz2 ^
	-T libs.debug

tar -cjf qt4-libs-%VERSION%-%PACKAGE%-src.tar.bz2 ^
	package.cmd ^
	postinstall.bat ^
	preremove.bat ^
	qt.conf.tmpl ^
	qt.diff ^
	qt4.bat ^
	libs.debug

tar -tjf qt4-doc-%VERSION%-%PACKAGE%.tar.bz2 >%OSGEO4W_ROOT%\etc\setup\qt4-doc.lst
tar -tjf qt4-devel-%VERSION%-%PACKAGE%.tar.bz2 >%OSGEO4W_ROOT%\etc\setup\qt4-devel.lst
tar -tjf qt4-libs-%VERSION%-%PACKAGE%.tar.bz2 >%OSGEO4W_ROOT%\etc\setup\qt4-libs.lst
tar -tjf qt4-libs-debug-%VERSION%-%PACKAGE%.tar.bz2 >%OSGEO4W_ROOT%\etc\setup\qt4-libs-debug.lst

gzip -f %OSGEO4W_ROOT%\etc\setup\qt4-doc.lst
gzip -f %OSGEO4W_ROOT%\etc\setup\qt4-devel.lst
gzip -f %OSGEO4W_ROOT%\etc\setup\qt4-libs.lst
gzip -f %OSGEO4W_ROOT%\etc\setup\qt4-libs-debug.lst

goto end

:error
echo ERROR %ERRORLEVEL%: %DATE% %TIME%

:end
echo END: %DATE% %TIME%
